#!/usr/bin/python3.4
import threading
from threading import Thread
import time
import datetime
import sys
import sqlite3
from time import sleep
import RPi.GPIO as GPIO, time
import RPi.GPIO as gpio
import shutil
import os

global count
global dbPath
global dbFileName
global backupPath
global wwwroot
global year_Month
monthstuple = ("januari", "februari", "mars", "april", "maj", "juni", "juli", "augusti", "september", "oktober", "november", "december")

count = 0
wwwroot = '/mnt/wwwroot/'
backupPath = wwwroot + 'COUNTER/'
# dbPath='/media/pi/COUNTER/'
dbPath='/home/pi/Counter/'
dbFileName='eventlog.db'
year_Month = (str(datetime.datetime.now())) 

print ("Ver 20190922  puffen@fagerholm.org")

def renameOldFiles():
    # Make a backup copy of eventlog.db to backupPath and rename the copy with year-month_eventlog.db
    print ("Copying " + dbPath + dbFileName + " to " + dbPath + year_Month[0:7] + "_" + dbFileName)
    shutil.copyfile(dbPath + dbFileName,dbPath + year_Month[0:7] + "_" + dbFileName)

    # Now rename the original eventlog.db to 2018-11_eventlog.db
    print ("Renaming  " + dbPath + dbFileName + " to " + dbPath + year_Month[0:7] + "_" + dbFileName)
    os.rename(dbPath + dbFileName,dbPath + year_Month[0:7] + "_" + dbFileName)    

    # Append to textfile output for webserver this month's amount
    #LastEvent= "Fram t.o.m. " + year_Month[0:7] + " har " + str(count) + " fordon passerat."
    LastEvent= "Under " + monthstuple[int(str(datetime.datetime.now())[5:7]) -2] + " har " + str(count) + " fordon passerat."
    fhandle=open('/mnt/wwwroot/aggregated.txt', 'a+')
    fhandle.write(LastEvent + "\n")  
    #fhandle.write('\n')
    #fhandle.write(LastEvent + " Eller? \n")

    fhandle.close()
    print ("Appended: " + LastEvent + " to /mnt/wwwroot/aggregateted.txt.")  

def makeNewdb(newName):    
    #Create a new db(newName)
    print ("Creating a new db: " + newName)
    conn=sqlite3.connect(newName)
    curs=conn.cursor()
    print ('Creating table')
    curs.execute('''create TABLE events(timestamp DATETIME, event TEXT)''')
    conn.commit()
    conn.close()
    # my_callback(1) 



# Turn off warnings about port already in use
GPIO.setwarnings(False)

# Use BCM numbers when adressing GPIO ports.
GPIO.setmode(GPIO.BCM)

# physical pin 23 is BCM pin 11, this is where impulses come in
GPIO.setup(11, GPIO.IN, pull_up_down=GPIO.PUD_UP)

# Red, Green and Blue LEDs are connected via resistors (130, 130, 2k4 ohm)
# to physical pins 11, 13, 15, and grounded on pin 9.
# BCM numbers are R=17, G=27, B=22
# GPIO# are 0, 2, 3 (Which I don't use here, only from bash using wiringpi)
GPIO.setup(17, GPIO.OUT) #Red
GPIO.setup(27, GPIO.OUT) #Green
GPIO.setup(22, GPIO.OUT) #Blue
# Turn off all LEDs
GPIO.output(17,0)
GPIO.output(27,0)
GPIO.output(22,0)
# Turn on red
GPIO.output(17,1)
# Turn on green  ToDo: Setting green to a slow blink just to show the program is still running
GPIO.output(27,1)
howTired = 1   # Seconds to sleep between each blink, maybe a factor of cpu and RAM usage


#######################################################
def my_callback(channel):
    # Turn on blue to show an event has occurred
    GPIO.output(22,1)
    # Inrease global counter
    global count
    count=count+1

    # Make html output for webserver
    LastEvent=str(count) + " fordon har passerat under " +  monthstuple[int(str(datetime.datetime.now())[5:7]) -1] + ". Sista passagen skedde " + datetime.datetime.strftime(datetime.datetime.now(), '%Y-%m-%d_%H.%M.%S')
    try:
        with open('/mnt/wwwroot/sista_passagen.txt', 'w') as fhandle:
            fhandle.write(LastEvent)   # Totalt har 88196 fordon passerat sedan 1/4. Sista passagen skedde 2017-01-25_18.38.11
    except IOError as e:
        print (str(e))
    
    # Print a line to program window
    prutt=datetime.datetime.strftime(datetime.datetime.now(), '%Y-%m-%d_%H.%M.%S'),count
    print (prutt,end=" ")       # ('2017-02-15_16.48.08', 95505)



    #Check if month has changed every time an event happens, if so, make a new db
    global year_Month
    if year_Month[5:7] != (str(datetime.datetime.now())[5:7]):
    #if year_Month[14:15] != (str(datetime.datetime.now())[14:15]):  # 14:15 ten minutes for test of month
        ###### Month has flipped.
        print ("Month has changed from " + year_Month[5:7] + " to " + (str(datetime.datetime.now())[5:7]))
        # First backup of db, this one also prints a monthly summary to the web.
        renameOldFiles()
        # then       
        makeNewdb(dbPath + dbFileName)
        # Reset count every new month from 20190922
        count = 0
        
        # check if year has changed, if so, add previously months count #Not implemented yet 20190922
        if year_Month[0:4] != (str(datetime.datetime.now())[0:4]):
        #if year_Month[11:13] != (str(datetime.datetime.now())[11:13]):  #11:13 hour, for test of new year
            ###### Year has flipped.
            print ("Year has changed from " + year_Month[5:7] + " to " + (str(datetime.datetime.now())[5:7]))
            # Append to textfile output for webserver this year's amount
            LastEvent= "Under hela " + year_Month[0:4] + " passerade totalt " + str(count) + " fordon.\n\n ######" , int(year_Month[0:4]) + 1, "######"
            try:
                fhandle=open('/mnt/wwwroot/aggregated.txt', 'a+')
                fhandle.write(LastEvent + "\n")   
                fhandle.close()
            except IOError as e:
                print (str(e))
            # Reset count every new year #Reset every month instead 20190922
            # count = 0
        # if month has changed, set year_Month to new year-month
        year_Month = (str(datetime.datetime.now()))
    
    # Go and log type of event "P" and count in the db
    log_event('P'+str(count))   # P95505
    # sleep(0.3)
    # Turn off blue
    GPIO.output(22,0)
# end of my_callback
################################################


###########################
def log_event(event):
    conn=sqlite3.connect(dbPath + dbFileName)
    curs=conn.cursor()
    print (event)               # P95505
    # shutil ('espeak "event"')
    curs.execute("INSERT INTO events (timestamp, event) values(?,?)",(datetime.datetime.now(),event))
    # commit the changes
    conn.commit()
    conn.close()
# end of log_event
##########################


####################################################
# Stuff done only once at start
####################################################
# add rising edge detection on a channel
GPIO.add_event_detect(11, GPIO.RISING, callback=my_callback, bouncetime=2000) 

# When program starts, this reads the last record in db to get last count and year
print ('loading....')

# Check if db exist, else create a new db
try:
    # conn=sqlite3.connect(dbPath + dbFileName)
    print ("Trying to open: " + dbPath + dbFileName)
    dummy=open(dbPath + dbFileName)
except IOError:
    print ("Error opening: " + dbPath + dbFileName)
    makeNewdb(dbPath + dbFileName)  #Create a new db(newName) #and connect to it and write one record to initiate it


conn=sqlite3.connect(dbPath + dbFileName)
curs=conn.cursor()
query=("SELECT event FROM events ORDER BY timestamp DESC LIMIT 1")

if (curs.execute(query)):     # If getting the last record from the db fails because it's a new db, set count to 0 in else
    prutt=curs.fetchone()[0]  # Now prutt is number of events recorded in database, taken from last record
    query=("SELECT timestamp FROM events ORDER BY timestamp DESC LIMIT 1")
    # Timestamp is last date recorded in database, taken from last record
    # Like this: 2018-11-19 20:49:13.739584
    curs.execute(query)
    year_Month=curs.fetchone()[0] #Get the first 4 chars of the first argument?
else:
    prutt= 0   # Set count to 0 since we didn't find any database (or event record) at all

print ("Sista sparade passagen var " + year_Month[:19] + " Antal: " + prutt[1:])
conn.close()

count=int(prutt[1:])   # Make an integer of the string, count is global
# count=7148   #set count hard to something for some reason, 20190825 last time
# at least one event must happen to commit to db
# count is beer counter -522   20190815 

####################################################
# End of Stuff done only once at start
####################################################


# These are just remarks about things nice to know.
# select event from events order by timestamp desc limit 1;

while(True):
    # Turn on green  ToDo: Setting green to a slow blink just to show the program is still running
    GPIO.output(27,1)
    # howTired = 1   # Seconds to sleep between each blink, maybe a factor of cpu and RAM usage
    sleep(howTired)

    # Turn off green  ToDo: Setting green to a slow blink just to show the program is still running
    GPIO.output(27,0)
    # howTired = 1   # Seconds to sleep between each blink, maybe a factor of cpu and RAM usage
    sleep(howTired)





